#pragma once

#include <vector>
#include "SimpleCriticalSection.h"

using namespace std;

class CMemoryPool
{
public:
	struct MEMORY_DESC {
		BYTE *pBuffer;
		bool bUsing;
		size_t Index;
	};

private:
	vector< MEMORY_DESC > pool_;
	HANDLE hEvent_;

public:
	CMemoryPool(size_t PoolSize, size_t MemorySize);
	~CMemoryPool(void);

private:
	CSimpleCriticalSection scs_;

private:
	int freeMemIndex_;
public:
	MEMORY_DESC *Take();
	void Release(MEMORY_DESC *pMD);
};
